diff -Nur openbsc.6_datalink/include/openbsc/select.h openbsc.7_select/include/openbsc/select.h
--- openbsc.6_datalink/include/openbsc/select.h	2009-05-21 07:20:43.000000000 +0200
+++ openbsc.7_select/include/openbsc/select.h	2009-05-21 09:20:32.000000000 +0200
@@ -18,5 +18,5 @@
 
 int bsc_register_fd(struct bsc_fd *fd);
 void bsc_unregister_fd(struct bsc_fd *fd);
-int bsc_select_main(void);
+int bsc_select_main(int polling);
 #endif /* _BSC_SELECT_H */
diff -Nur openbsc.6_datalink/src/bs11_config.c openbsc.7_select/src/bs11_config.c
--- openbsc.6_datalink/src/bs11_config.c	2009-05-21 07:55:52.000000000 +0200
+++ openbsc.7_select/src/bs11_config.c	2009-05-21 09:20:32.000000000 +0200
@@ -790,7 +790,7 @@
 	status_timer.cb = status_timer_cb;
 
 	while (1) {
-		bsc_select_main();
+		bsc_select_main(0);
 	}
 
 	abis_nm_bs11_factory_logon(g_bts, 0);
diff -Nur openbsc.6_datalink/src/bsc_hack.c openbsc.7_select/src/bsc_hack.c
--- openbsc.6_datalink/src/bsc_hack.c	2009-05-21 07:20:44.000000000 +0200
+++ openbsc.7_select/src/bsc_hack.c	2009-05-21 09:17:27.000000000 +0200
@@ -1123,6 +1123,6 @@
 	signal(SIGABRT, &signal_handler);
 
 	while (1) {
-		bsc_select_main();
+		bsc_select_main(0);
 	}
 }
diff -Nur openbsc.6_datalink/src/ipaccess-config.c openbsc.7_select/src/ipaccess-config.c
--- openbsc.6_datalink/src/ipaccess-config.c	2009-05-21 07:20:44.000000000 +0200
+++ openbsc.7_select/src/ipaccess-config.c	2009-05-21 09:21:41.000000000 +0200
@@ -188,7 +188,7 @@
 	}
 	
 	while (1) {
-		rc = bsc_select_main();
+		rc = bsc_select_main(0);
 		if (rc < 0)
 			exit(3);
 	}
diff -Nur openbsc.6_datalink/src/ipaccess-find.c openbsc.7_select/src/ipaccess-find.c
--- openbsc.6_datalink/src/ipaccess-find.c	2009-05-21 07:56:25.000000000 +0200
+++ openbsc.7_select/src/ipaccess-find.c	2009-05-21 09:20:32.000000000 +0200
@@ -170,7 +170,7 @@
 	printf("Trying to find ip.access BTS by broadcast UDP...\n");
 
 	while (1) {
-		rc = bsc_select_main();
+		rc = bsc_select_main(0);
 		if (rc < 0)
 			exit(3);
 	}
diff -Nur openbsc.6_datalink/src/select.c openbsc.7_select/src/select.c
--- openbsc.6_datalink/src/select.c	2009-05-21 07:50:34.000000000 +0200
+++ openbsc.7_select/src/select.c	2009-05-21 09:20:32.000000000 +0200
@@ -53,11 +53,12 @@
 	llist_del(&fd->list);
 }
 
-int bsc_select_main()
+int bsc_select_main(int polling)
 {
 	struct bsc_fd *ufd, *tmp;
 	fd_set readset, writeset, exceptset;
-	int i;
+	int work = 0, rc;
+	struct timeval no_time = {0, 0};
 
 	FD_ZERO(&readset);
 	FD_ZERO(&writeset);
@@ -75,10 +76,11 @@
 			FD_SET(ufd->fd, &exceptset);
 	}
 
-	bsc_prepare_timers();
-	i = select(maxfd+1, &readset, &writeset, &exceptset, bsc_nearest_timer());
-	if (i < 0)
-		return i;
+	if (!polling)
+		bsc_prepare_timers();
+	rc = select(maxfd+1, &readset, &writeset, &exceptset, polling ? &no_time : bsc_nearest_timer());
+	if (rc < 0)
+		return 0;
 
 	/* fire timers */
 	bsc_update_timers();
@@ -96,8 +98,10 @@
 		if (FD_ISSET(ufd->fd, &exceptset))
 			flags |= BSC_FD_EXCEPT;
 
-		if (flags)
+		if (flags) {
+			work = 1;
 			ufd->cb(ufd, flags);
+		}
 	}
-	return i;
+	return work;
 }
diff -Nur openbsc.6_datalink/tests/timer/timer_test.c openbsc.7_select/tests/timer/timer_test.c
--- openbsc.6_datalink/tests/timer/timer_test.c	2009-05-21 07:57:10.000000000 +0200
+++ openbsc.7_select/tests/timer/timer_test.c	2009-05-21 09:23:08.000000000 +0200
@@ -65,6 +65,6 @@
     bsc_schedule_timer(&timer_three, 4, 0);
 
     while (1) {
-        bsc_select_main();
+        bsc_select_main(0);
     }
 }
